###################
# SVM Experiments
#
def rcv1_string(svm_exec, mu, splits, step_initial, step_decay):
    output_name = "output/svm.{the_exec}.splits.{splits}.step_initial.{step_initial}.step_decay.{step_decay}.log".format(the_exec=svm_exec.replace('/', '.'), splits=splits, step_initial=step_initial, step_decay=step_decay)
    return "{the_exec} --mu {mu} --binary 1 --splits {splits} --stepinitial {step_initial} --step_decay {step_decay} /raid/chrisre/RCV.binary.train.dat data/RCV1/RCV1.test.dat > {output_name}".format(the_exec=svm_exec, mu=mu, splits=splits, step_initial=step_initial, step_decay=step_decay, output_name=output_name)

svm_execs = ["exec/svm_generic_atomic"]
svm_mu    = 0.01

def print_svmparm_strings():
    for svm_exec in svm_execs:
        for splits in range(1,11):
            for step_initial in [0.5]:
                    for step_decay in [0.8]:
                        print rcv1_string(svm_exec, svm_mu, splits,step_initial,step_decay)

###################
# Cut Experiments
#

def abdomen_cut_binary(cut_exec, mu, splits, step_initial, step_decay):
    output_name = "output/abdomen.cut.{the_exec}.splits.{splits}.step_initial.{step_initial}.step_decay.{step_decay}.log".format(the_exec=cut_exec.replace('/', '.'), splits=splits, step_initial=step_initial, step_decay=step_decay)
    return "{the_exec} --mu {mu} --binary 1 --splits {splits} --stepinitial {step_initial} --step_decay {step_decay} /raid/chrisre/abdomen.binary.day one.txt two.txt > {output_name}".format(the_exec=cut_exec, mu=mu, splits=splits, step_initial=step_initial, step_decay=step_decay, output_name=output_name)

cut_execs = ["exec/cut_generic_atomic"]
def print_abdomen_strings():
    for cut_exec in cut_execs:
        for splits in range(1,11):
            for step_initial in [0.1]:
                    for step_decay in [0.9]:
                        print abdomen_cut_binary(cut_exec, svm_mu, splits,step_initial,step_decay)

#############
# Multicut

def dblife_multi_cut_binary(cut_exec, mu, splits, step_initial, step_decay):
    output_name = "output/dblife.multicut.{the_exec}.splits.{splits}.step_initial.{step_initial}.step_decay.{step_decay}.log".format(the_exec=cut_exec.replace('/','.'), splits=splits, step_initial=step_initial, step_decay=step_decay)
    return "{the_exec} --mu {mu} --binary 1 --splits {splits} --stepinitial {step_initial} --step_decay {step_decay} /raid/chrisre/dblife.binary.examples.dat T.txt > {output_name}".format(the_exec=cut_exec, mu=mu, splits=splits, step_initial=step_initial, step_decay=step_decay, output_name=output_name)

multicut_execs = ["exec/multicut_generic_atomic"]

def print_dblife_strings():
    for cut_exec in multicut_execs:
        for splits in range(1,11):
            for step_initial in [0.1]:
                    for step_decay in [0.95]:
                        print dblife_multi_cut_binary(cut_exec, svm_mu, splits,step_initial,step_decay)

####################
# Matrix Factorization
#
def matrix_binary(cut_exec, mu, splits, step_initial, step_decay, train_file, probe_file, moniker):
    output_name = "output/{moniker}.matrix.{the_exec}.splits.{splits}.step_initial.{step_initial}.step_decay.{step_decay}.log".format(the_exec=cut_exec.replace('/','.'), splits=splits, step_initial=step_initial, step_decay=step_decay, moniker=moniker)
    return "{the_exec} --mu {mu} --maxrank 30 --epochs 20 --stepinitial {step_initial} --step_decay {step_decay} --splits {splits} --file_scan 1 {train_file} {probe_file} > {output_name}".format(the_exec=cut_exec, mu=mu, splits=splits, step_initial=step_initial, step_decay=step_decay, output_name=output_name, train_file=train_file, probe_file=probe_file)

matrix_datasets = [("huge", "/raid/chrisre/HUGE.train.nr=10000000.alpha=1.rrank=10.oversample=10.noise_var=0.001.factor_type=0.data", "/raid/chrisre/HUGE.probe.nr=10000000.alpha=1.rrank=10.oversample=10.noise_var=0.001.factor_type=0.data"),
                   #("kddcup", "/raid/chrisre/kdd.cup.trainIDx1.binary.txt", "/raid/chrisre/validationIdx1.dat"),
                   #("netflix", "/raid/chrisre/train_set.binary.dat", "/scratch.2/chrisre/MPC/probe_set.dat")
                   ]

tracenorm_execs = ["exec/tracenorm_atomic"]
def print_matrix_strings():
    for cut_exec in tracenorm_execs:
        for splits in range(1,11):
            for step_initial in [0.001]:
                    for step_decay in [0.95]:
                        for (moniker, train_set, probe_set) in matrix_datasets:
                            print matrix_binary(cut_exec, svm_mu, splits,step_initial,step_decay, train_set, probe_set, moniker)

def print_big_matrix_strings():
    for cut_exec in tracenorm_execs:
        splits = 10
        for step_initial in [0.001]:
            for step_decay in [0.95]:
                for (moniker, train_set, probe_set) in matrix_datasets:
                    print matrix_binary(cut_exec, svm_mu, splits,step_initial,step_decay, train_set, probe_set, moniker)

def create_scaleup():
    print_svmparm_strings()
    print_dblife_strings()
    print_abdomen_strings()
    print_matrix_strings()
    print_big_matrix_strings()

